'From SqueakNihongo6.1 of 17 April 2004 [latest update: #1] on 7 July 2004 at 9:58:49 am'!
"Change Set:		ScamperWorkspace-20040707
Date:			5 July 2004
Author:			Takashi Yamamiya

Scamper as Workspace.
- self in web page refferes the Scamper.
- Context menu
- Workspace variable
- Scamper32 support
- fix for < .. /> tag.
- fix for <? .. ?> tag (it is recognized as normal tag).
- Now Case sensitivity on characterset is ignored.
- Post (EUC JP only)

This changeset is for Scamper32 with NihognoScamper 0.4.
http://ich.homelinux.net:8080/squeak/uploads/NihongoScamper.1.cs

"
Scamper StartUrl: 'http://languagegame.org:8080/propella/91'.
Preferences setParameter: #languageTranslateTo to: 'Japanese'.
Preferences setParameter: #languageTranslateFrom to: 'English'.
!

Model subclass: #Scamper
	instanceVariableNames: 'status currentUrl pageSource document formattedPage downloadingProcess documentQueue recentDocuments currentAnchorLocation currentUrlIndex backgroundColor bookmark bookDir bindings '
	classVariableNames: 'StartUrl '
	poolDictionaries: ''
	category: 'Network-Web Browser'!

!AbstractString methodsFor: 'babelCompatible' stamp: 'tak 6/23/2004 21:50'!
evaluateExpression: aString parameters: aCollection 
	"private - evaluate the expression aString with  
	aCollection as the parameters and answer the  
	evaluation result as an string"
	| index |
	index := ('0' , aString) asNumber.

	index isZero
		ifTrue: [^ '[invalid subscript: {1}]' format: {aString}].

	index > aCollection size
		ifTrue: [^ '[subscript is out of bounds: {1}]' format: {aString}].

	^ (aCollection at: index) asString! !

!AbstractString methodsFor: 'babelCompatible' stamp: 'tak 6/23/2004 21:50'!
format: aCollection 
	"format the receiver with aCollection  
	 
	simplest example:  
	'foo {1} bar' format: {Date today}.
	 
	complete example:  
	'\{ \} \\ foo {1} bar {2}' format: {12. 'string'}.  
	"
	| result stream |
	result := String new writeStream.
	stream := self readStream.

	[stream atEnd]
		whileFalse: [| currentChar | 
			currentChar := stream next.
			currentChar == ${
				ifTrue: [| expression | 
					expression := self getEnclosedExpressionFrom: stream.
					result
						nextPutAll: (self evaluateExpression: expression parameters: aCollection)]
				ifFalse: [
					currentChar == $\
						ifTrue: [stream atEnd
								ifFalse: [result nextPut: stream next]]
						ifFalse: [result nextPut: currentChar]]].

	^ result contents! !

!AbstractString methodsFor: 'babelCompatible' stamp: 'tak 6/23/2004 21:50'!
getEnclosedExpressionFrom: aStream 
	"private - get the expression enclosed between '{' and 
	'}' and remove all the characters from the stream"
	| result currentChar |
	result := String new writeStream.

	[aStream atEnd 
		or: [(currentChar := aStream next) == $}]]
		whileFalse: [result nextPut: currentChar].

	^ result contents withBlanksTrimmed! !

!AbstractString methodsFor: 'babelCompatible' stamp: 'tak 6/23/2004 21:50'!
translated
	^ self! !


!FreeTranslation class methodsFor: 'scamper' stamp: 'tak 7/7/2004 09:44'!
openGooDictionaryScamperOn: currentSelection 
	"Submit the string to the translation server at dictionary.goo.ne.jp."
	| inputs scamperWindow |
	inputs _ Dictionary new.
	inputs at: 'MT' put: {currentSelection}.
	inputs at: 'kind' put: #('ej' ).
	scamperWindow _ (WebBrowser default
				ifNil: [^ self])
				newOrExistingOn: 'http://dictionary.goo.ne.jp/search.php'.
	scamperWindow model
		submitFormWithInputs: inputs
		url: 'http://dictionary.goo.ne.jp/search.php' asUrl
		method: 'GET'.
	scamperWindow activate! !

!FreeTranslation class methodsFor: 'scamper' stamp: 'tak 7/7/2004 09:41'!
openScamperOn: currentSelection
	"Submit the string to the translation server at www.freetranslation.com.  Ask it to translate from (Preferences parameterAt: #languageTranslateFrom) to (Preferences parameterAt: #languageTranslateTo).  Display the results in a Scamper window, reusing the previous one if possible."

	| inputs scamperWindow from to | 
	currentSelection size >= 10000 ifTrue: [^ self inform: 'Text selection is too long.'].
	from _ Preferences parameterAt: #languageTranslateFrom ifAbsentPut: ['English'].
	to _ Preferences parameterAt: #languageTranslateTo ifAbsentPut: ['German'].
	from = to ifTrue:
			[^ self inform: 'You asked to translate from ', from, ' to ', to, '.\' withCRs,
				'Use "choose language" to set these.'].
	to = 'Japanese' ifTrue: [ ^self openGooDictionaryScamperOn: currentSelection ].
	inputs _ Dictionary new.
	inputs at: 'SrcText' put: (Array with: currentSelection).
	inputs at: 'Sequence' put: #('core').
	inputs at: 'Mode' put: #('html').
	inputs at: 'template' put: #('TextResult2.htm').
	inputs at: 'Language' put: (Array with: from, '/', to).
	scamperWindow _ (WebBrowser default ifNil: [^self]) newOrExistingOn: 'http://ets.freetranslation.com'.
	scamperWindow model submitFormWithInputs: inputs 
		url: 'http://ets.freetranslation.com:5081' asUrl
		method: 'post'.
	scamperWindow activate.
! !


!HtmlEntity class methodsFor: 'character entities' stamp: 'tak 6/20/2004 18:34'!
valueOfHtmlEntity: specialEntity
	"Return the character equivalent to the HTML entity."

	| value |
	(specialEntity beginsWith: '#')		"Handle numeric entities"
		ifTrue: [
			"NB: We can display only simple numeric special entities in the"
			"range [9..255] (HTML 3.2).  HTML 4.01 allows the specification of 16 bit"
			"characters, so we do a little fiddling to handle a few special cases"

			value _ ('Xx' includes: specialEntity second)
				ifTrue: [Number readFrom: '16r', (specialEntity allButFirst: 2) asUppercase]
				ifFalse: [specialEntity allButFirst asNumber].

			"Replace rounded left & right double quotes (HTML 4.01) with simple double quote"
			(value = 8220 or: [value = 8221]) ifTrue: [ value _ $" asInteger ].

			"Replace rounded left & right single quotes (HTML 4.01) with simple single quote"
			(value = 8216 or: [value = 8217]) ifTrue: [ value _ $' asInteger ].

			"Replace with a space if outside the normal range (arbitrary choice)" 
			(value < 9 or: [value > 255]) ifTrue: [ value _ 32 ].
			]
		ifFalse: [
			"Otherwise this is most likely a named character entity"
			value _ ReverseCharacterEntities at: specialEntity ifAbsent: [^nil].
			].

	 ^Character value: value.! !


!HtmlMeta methodsFor: 'formatting' stamp: 'tak 7/5/2004 17:11'!
charset
	(self getAttribute: #'http-equiv')
		ifNil: [^ nil].
	(self getAttribute: #'http-equiv') asLowercase = 'content-type'
		ifFalse: [^ nil].
	((self getAttribute: #content)
		findTokens: '; ')
		do: [:each | (each beginsWith: 'charset')
				ifTrue: [^ (each findTokens: '= ')
						at: 2]].
	^ nil! !


!HtmlTokenizer methodsFor: 'private-tokenizing' stamp: 'tak 6/20/2004 18:23'!
nextTag
	"we've seen a < and peek-ed something other than a !!.  Parse and return a tag"
	| source negated name attribs attribName attribValue sourceStart sourceEnd c |
	
	sourceStart _ pos-1.
	attribs _ Dictionary new.

	"determine if its negated"
	self peekChar = $/ 
		ifTrue: [ negated _ true.  self nextChar. ]
		ifFalse: [ negated _ false ].

	"read in the name"
	self skipSpaces.
	name _ self nextName.
	name _ name asLowercase.

	"read in any attributes"
	[ 	self skipSpaces.
		c _ self peekChar.
		c = nil or: [(c isLetter or: ['?/' includes: c]) not ]
	] whileFalse: [
		attribName _ self nextName.
		attribName _ attribName asLowercase.
		self skipSpaces.
		self peekChar = $= 
			ifTrue: [ 
				self nextChar.
				self skipSpaces.
				attribValue _ self nextAttributeValue withoutQuoting  ]
			ifFalse: [ attribValue _ '' ].
		attribs at: attribName  put: attribValue ].

	self peekChar = $> ifTrue: [ self nextChar ].

	sourceEnd _ pos-1.
	source _ text copyFrom: sourceStart to: sourceEnd.

	^HtmlTag source: source name: name asLowercase negated: negated attribs: attribs! !


!MultiString methodsFor: 'converting' stamp: 'tak 7/5/2004 15:47'!
encodeForHTTP
	self flag: #toBeImplemented.
	^ (self convertToWithConverter: EUCJPTextConverter new) encodeForHTTP! !


!Scamper methodsFor: 'menus' stamp: 'tak 7/7/2004 09:48'!
menu: menu shifted: shifted 
	menu addList: 
#(
('back'	back)
('forward'	forward)
-
('do it (d)'			doIt)
('print it (p)'		printIt)
('inspect it (i)'		inspectIt)
('file it in (G)'		fileItIn)
('debug it'			debugIt)
-
('new URL'	jumpToNewUrl)
('history'	displayHistory)
-
('view source'	viewSource)
('inspect parse tree'	inspectParseTree)
-
('go to start page'	visitStartPage)
('edit start page'	editStartPage)
('bookmark'	bookmark)
('translate'	translateIt)
).

	downloadingProcess
		ifNotNil: 
			[menu addList: #(
				-
				('stop downloading'	stopEverything)
				)].

	^ menu! !

!Scamper methodsFor: 'changing page' stamp: 'tak 6/23/2004 22:05'!
jumpToAbsoluteUrl: urlText
	"start downloading a new page.  The page source is downloaded in a background thread"
	|  newUrl newSource morph |

	self stopEverything.

	"get the new url"
	newUrl _ urlText asUrl.


	"if it fundamentally doesn't fit the pages-and-contents model used internally, spawn off an external viewer for it"
	newUrl hasContents ifFalse: [ newUrl activate.  ^true ].

	"fork a Process to do the actual downloading, parsing, and formatting.  It's results will be picked up in #step"
	self status: ('downloading {1}...' translated format:{newUrl toText}).

	downloadingProcess _ [ 
	  	newSource _ [ newUrl retrieveContentsForBrowser: self ] ifError: [ :msg :ctx |
			MIMEDocument contentType: 'text/plain' content: msg ].

		newSource 
			ifNil: [ newSource _ MIMEDocument contentType: 'text/plain' content: 'Error retrieving this URL' translated].

			newSource url ifNil: [
				newSource _ MIMEDocument contentType: newSource contentType  content: newSource content  url: newUrl ].

			documentQueue nextPut: newSource.
			downloadingProcess _ nil.
	] newProcess.

	downloadingProcess resume.

	[recentDocuments size > currentUrlIndex] whileTrue: [
		"delete all elements in recentDocuments after currentUrlIndex"
		recentDocuments removeLast.
	].
	currentUrlIndex _ currentUrlIndex + 1.
	morph _ self containingWindow.
	morph ifNotNil: [morph start].

	^true! !

!Scamper methodsFor: 'document handling' stamp: 'tak 6/23/2004 22:50'!
displayTextHtmlPage: newSource
	"HTML page--format it"
	| formatter bgimageUrl bgimageDoc bgimage |
	currentUrl _ newSource url.
	pageSource _ newSource content.
	self status: 'parsing...' translated.
	document _ HtmlParser parse: (ReadStream on: pageSource).
	document _ HtmlParser parse: document asHtmlAfterScripts.
	document replaceAllTextsToMultiString.
	self status: 'laying out...' translated.
	formatter _ HtmlFormatter preferredFormatterClass new.
	formatter browser: self.
	formatter baseUrl: currentUrl.
	document addToFormatter: formatter.

	formattedPage _ formatter text.
	(bgimageUrl _ document body background)
		ifNotNil:
			[bgimageDoc _ (bgimageUrl asUrlRelativeTo: currentUrl) retrieveContents.
			[bgimage _ ImageReadWriter formFromStream: bgimageDoc contentStream binary]
				ifError: [:err :rcvr | "ignore" bgimage _ nil]].
	bgimage
		ifNotNil: [backgroundColor _ bgimage]
		ifNil: [backgroundColor _ Color fromString: document body bgcolor].
	currentUrl fragment
		ifNil: [ currentAnchorLocation _ nil ]
		ifNotNil: [ currentAnchorLocation _
				formatter anchorLocations 
					at: currentUrl fragment asLowercase
					ifAbsent: [ nil ] ].

	self startDownloadingMorphState: (formatter incompleteMorphs).

	self changeAll: 	#(currentUrl relabel hasLint lint backgroundColor formattedPage formattedPageSelection).
	self status: 'done.' translated.
	"pardon this horrible hack...(tk)"
	(currentUrl authority beginsWith: 'ets.freetranslation.com') ifTrue: [
		self status: 'done.
**** Please Scroll Down To See Your Results ****' translated].
	^true! !

!Scamper methodsFor: 'not yet categorized' stamp: 'tak 5/12/2004 16:17'!
doItReceiver
	^self! !

!Scamper methodsFor: 'bindings' stamp: 'tak 5/9/2004 16:08'!
bindingOf: aString
	bindings isNil
		ifTrue: [bindings _ Dictionary new].
	(bindings includesKey: aString)
		ifFalse: [bindings at: aString put: nil].
	^bindings associationAt: aString! !


!TechoInfo class methodsFor: 'instance creation' stamp: 'tak 7/7/2004 09:58'!
scamperPackage
"Includes ...
Scamper
http://map1.squeakfoundation.org/sm/accountbyid/a6930213-b578-49b1-862e-228cc5ab39e7/files/Scamper-md.3.mcz
http://map1.squeakfoundation.org/sm/accountbyid/a6930213-b578-49b1-862e-228cc5ab39e7/files/Network-HTML-md.3.mcz

ScamperScript
http://lists.squeakfoundation.org/pipermail/squeak-ja/2004-June/001658.html
ScamperScript.2.cs

http://ich.homelinux.net:8080/squeak/uploads/48/ScamperBugFix.2.cs
http://ich.homelinux.net:8080/squeak/uploads/NihongoScamper.1.cs

http://lists.squeakfoundation.org/pipermail/squeak-ja/2004-April/001433.html
ZipArchiveMember-compressDataTo

http://lists.squeakfoundation.org/pipermail/squeak-ja/2004-April/001549.html
withSeparatorsCompacted-tak

ScamperWorkspace-2004-07-05
ScamperFix-20040705
"
	| info |
	info _ self new.
	info prerequisiteChangeSets: #('Network-HTML-md.3' 'Scamper-md.3' 'ScamperScript' 'ScamperBugFix' 'NihongoScamper' 'withSeparatorsCompacted-tak' 'ZipArchiveMember-compressDataTo' 'ScamperWorkspace-20040707' 'ScamperFix-20040705').
	^ info! !

